/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_device_mt9v03x
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2021-12-23        W            ͷɼɱ־λvolatile
* 2022-03-26        W            ޸ĲֲҪע
* 2022-09-15        W            first version
********************************************************************************************************************/
/*********************************************************************************************************************
* ߶壺
*                   ------------------------------------
*                   ģܽ            Ƭܽ
*                   TXD                 鿴 zf_device_mt9v03x.h  MT9V03X_COF_UART_TX        궨
*                   RXD                 鿴 zf_device_mt9v03x.h  MT9V03X_COF_UART_RX        궨
*                   D0                  鿴 zf_device_mt9v03x.h  MT9V03X_D0_PIN             궨
*                   D1                  鿴 zf_device_mt9v03x.h  MT9V03X_D1_PIN             궨
*                   D2                  鿴 zf_device_mt9v03x.h  MT9V03X_D2_PIN             궨
*                   D3                  鿴 zf_device_mt9v03x.h  MT9V03X_D3_PIN             궨
*                   D4                  鿴 zf_device_mt9v03x.h  MT9V03X_D4_PIN             궨
*                   D5                  鿴 zf_device_mt9v03x.h  MT9V03X_D5_PIN             궨
*                   D6                  鿴 zf_device_mt9v03x.h  MT9V03X_D6_PIN             궨
*                   D7                  鿴 zf_device_mt9v03x.h  MT9V03X_D7_PIN             궨
*                   PCLK                鿴 zf_device_mt9v03x.h  MT9V03X_PCLK_PIN           궨
*                   VSYNC               鿴 zf_device_mt9v03x.h  MT9V03X_VSY_PIN            궨
*                   HSYNC               鿴 zf_device_mt9v03x.h  MT9V03X_HERF_PIN           궨
*                   ------------------------------------
********************************************************************************************************************/

#ifndef _zf_device_mt9v03x_h_
#define _zf_device_mt9v03x_h_


#include "zf_common_typedef.h"


//--------------------------------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------------------------------
#define MT9V03X_COF_UART        (UART_5     )                		// ͷʹõĴ
#define MT9V03X_COF_BAUR        (9600       )                		// ôڲ
#define MT9V03X_COF_UART_TX     (UART5_MAP0_RX_D2)           		//  UART-TX  ҪڵƬ RX 
#define MT9V03X_COF_UART_RX     (UART5_MAP0_TX_C12)       		    //  UART-RX  ҪڵƬ TX 

#define MT9V03X_COF_IIC_DELAY   (500)                               //  IIC ʱ
#define MT9V03X_COF_IIC_SCL     (D2)                               //  IIC-SCL 
#define MT9V03X_COF_IIC_SDA     (C12)                               //  IIC-SDA 

#define MT9V03X_D0_PIN      	(A9	)
#define MT9V03X_D1_PIN      	(A10)
#define MT9V03X_D2_PIN      	(C8 )
#define MT9V03X_D3_PIN      	(C9 )
#define MT9V03X_D4_PIN      	(C11)
#define MT9V03X_D5_PIN      	(B6 )
#define MT9V03X_D6_PIN      	(B8 )
#define MT9V03X_D7_PIN      	(B9 )
	
#define MT9V03X_PCLK_PIN    	(A6 )
#define MT9V03X_VSY_PIN     	(A5 )
#define MT9V03X_HERF_PIN    	(A4 )
#define MT9V03X_INIT_TIMEOUT    (200)                          	// Ĭϵͷʼʱʱ Ϊλ

//--------------------------------------------------------------------------------------------------
// ͷĬϲ ڴ޸ͷ
//--------------------------------------------------------------------------------------------------
#define MT9V03X_W               (188)                           	// ͼ     Χ [1-752]
#define MT9V03X_H               (120)                           	// ͼ߶     Χ [1-480]
#define MT9V03X_IMAGE_SIZE      (MT9V03X_W * MT9V03X_H)           // ͼСܳ 65535
#define MT9V03X_COF_BUFFER_SIZE (64)                             // ôڻС  64

#define MT9V03X_AUTO_EXP_DEF    (0)                           	// Զع     ĬϲԶع  Χ [0-63] 0Ϊر
																	//                  Զع⿪  EXP_TIMEԶعʱ
																	//                  һǲҪԶع ߷ǳȵԳԶع⣬ͼȶ
#define MT9V03X_EXP_TIME_DEF    (512)                           	// عʱ         ͷյԶعʱ䣬ùΪعֵ
#define MT9V03X_FPS_DEF         (100)                           	// ͼ֡         ͷյԶFPSΪFPS
#define MT9V03X_LR_OFFSET_DEF   (0)                           	// ͼƫ   ֵ ƫ   ֵ ƫ  Ϊ188 376 752ʱ޷ƫ
																	//                  ͷƫݺԶƫƣüƫ
#define MT9V03X_UD_OFFSET_DEF   (0)                           	// ͼƫ   ֵ ƫ   ֵ ƫ  Ϊ120 240 480ʱ޷ƫ
																	//                  ͷƫݺԶƫƣüƫ
#define MT9V03X_GAIN_DEF        (32)                           	// ͼ         Χ [16-64]  عʱ̶¸ıͼ̶
#define MT9V03X_PCLK_MODE_DEF   (1)                           	// ʱģʽ     Χ [0-1]    Ĭϣ0 ѡΪ[0ź,1ź]
                                                                    //                  ͨΪ0ʹCH32V307DVPӿڻSTM32DCMIӿڲɼҪΪ1
                                                                    //                   MT9V034 V1.5 Լϰ汾ָ֧
																				
// ͷö
typedef enum
{
    MT9V03X_INIT = 0,                              						// ͷʼ
    MT9V03X_AUTO_EXP,                              						// Զع
    MT9V03X_EXP_TIME,                              						// عʱ
    MT9V03X_FPS,                                   						// ͷ֡
    MT9V03X_SET_COL,                               						// ͼ
    MT9V03X_SET_ROW,                               						// ͼ
    MT9V03X_LR_OFFSET,                             						// ͼƫ
    MT9V03X_UD_OFFSET,                             						// ͼƫ
    MT9V03X_GAIN,                                  						// ͼƫ
    MT9V03X_PCLK_MODE,                             						// ʱģʽ(MT9V034 V1.5Լϰ汾ָ֧)
    MT9V03X_CONFIG_FINISH,                         						// λҪռλ
						
    MT9V03X_COLOR_GET_WHO_AM_I = 0xEF,						
    MT9V03X_SET_EXP_TIME = 0XF0,                   						// عʱ
    MT9V03X_GET_STATUS,                            						// ȡͷ
    MT9V03X_GET_VERSION,                           						// ̼汾
						
    MT9V03X_SET_ADDR = 0XFE,                       						// Ĵַ
    MT9V03X_SET_DATA                               						// Ĵ
}m9v03x_cmd_enum;


// ͷӿö
typedef enum
{
    MT9V03X_UART,
    MT9V03X_SCCB,
}mt9v03x_type_enum;

extern volatile vuint8    mt9v03x_finish_flag;//һͼɼɱ־λ
extern uint8    mt9v03x_image[MT9V03X_H][MT9V03X_W];

void   mt9v03x_uart_callback      (void);
void   mt9v03x_handler            (void);
uint16 mt9v03x_get_version        (void);
uint8  mt9v03x_set_exposure_time  (uint16 light);
uint8  mt9v03x_set_reg            (uint8 addr, uint16 data);
uint8  mt9v03x_init               (void);

void mt9v03x_dvp_handler(void);
void mt9v03x_uart_handler (void);
uint8 mt9v03x_sccb_init (void);
uint8 mt9v03x_uart_init (void);

#endif
