/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_device_scc8660_dvp
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/
/*********************************************************************************************************************
*߶壺
*                   ------------------------------------
*                   ģܽ            Ƭܽ
*                   TXD                 鿴 zf_device_scc8660.h  SCC8660_COF_UART_TX_DVP        궨
*                   RXD                 鿴 zf_device_scc8660.h  SCC8660_COF_UART_RX_DVP        궨
*                   D0                  鿴 zf_device_scc8660.h  SCC8660_D0_PIN_DVP             궨
*                   D1                  鿴 zf_device_scc8660.h  SCC8660_D1_PIN_DVP             궨
*                   D2                  鿴 zf_device_scc8660.h  SCC8660_D2_PIN_DVP             궨
*                   D3                  鿴 zf_device_scc8660.h  SCC8660_D3_PIN_DVP             궨
*                   D4                  鿴 zf_device_scc8660.h  SCC8660_D4_PIN_DVP             궨
*                   D5                  鿴 zf_device_scc8660.h  SCC8660_D5_PIN_DVP             궨
*                   D6                  鿴 zf_device_scc8660.h  SCC8660_D6_PIN_DVP             궨
*                   D7                  鿴 zf_device_scc8660.h  SCC8660_D7_PIN_DVP             궨
*                   PCLK                鿴 zf_device_scc8660.h  SCC8660_PCLK_PIN_DVP           궨
*                   VSYNC               鿴 zf_device_scc8660.h  SCC8660_VSY_PIN_DVP            궨
*                   HSYNC               鿴 zf_device_scc8660.h  SCC8660_HERF_PIN_DVP           궨
*                   ------------------------------------
********************************************************************************************************************/


#ifndef _zf_device_scc8660_h_
#define _zf_device_scc8660_h_

#include "zf_common_typedef.h"

//--------------------------------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------------------------------
#define SCC8660_COF_UART        UART_5                                          // ͷʹõĴ
#define SCC8660_COF_BAUR        9600                                            // ͷõĴڲ ֹ޸
#define SCC8660_COF_UART_RX     UART5_MAP0_TX_C12                               // ͷ  UART-RX  ҪڵƬ TX 
#define SCC8660_COF_UART_TX     UART5_MAP0_RX_D2                                // ͷ  UART-TX  ҪڵƬ RX 

#define SCC8660_COF_IIC_DELAY   (200)                                           // ͫ IIC ʱ
#define SCC8660_COF_IIC_SCL     (D2)                                            // ͫ IIC-SCL 
#define SCC8660_COF_IIC_SDA     (C12)                                           // ͫ IIC-SDA 

#define SCC8660_D0_PIN          (A9 )
#define SCC8660_D1_PIN          (A10)
#define SCC8660_D2_PIN          (C8 )
#define SCC8660_D3_PIN          (C9 )
#define SCC8660_D4_PIN          (C11)
#define SCC8660_D5_PIN          (B6 )
#define SCC8660_D6_PIN          (B8 )
#define SCC8660_D7_PIN          (B9 )

#define SCC8660_PCLK_PIN        (A6 )
#define SCC8660_VSY_PIN         (A5 )
#define SCC8660_HERF_PIN        (A4 )
#define SCC8660_INIT_TIMEOUT    (0x0080)                                        // Ĭϵͷʼʱʱ Ϊλ

//--------------------------------------------------------------------------------------------------
// ͷĬϲ ڴ޸ͷ
//--------------------------------------------------------------------------------------------------
#define SCC8660_W               (160)                                           // ʵͼֱʿ ѡΪ160 180
#define SCC8660_H               (120)                                           // ʵͼֱʸ߶ ѡΪ120 160
#define SCC8660_IMAGE_SIZE      ( SCC8660_W * 2 * SCC8660_H )                   // ͼС SCC8660_W*2*SCC8660_H ܳ 65535
#define SCC8660_COF_BUFFER_SIZE ( 64  )                                         // ôڻС

#define SCC8660_AUTO_EXP_DEF    (0  )                                           // Զع     ĬϲԶع  Χ [0-1] 0Ϊر
#define SCC8660_BRIGHT_DEF      (300)                                           //      ֶعĬϣ300   ֶعʱΧ0-65535   ԶعƼֵ100 Զعʱ÷Χ0-255
#define SCC8660_FPS_DEF         (60 )                                           // ͼ֡     Ĭϣ60        ѡΪ60 50 30 25 ʵ֡ʻҪSCC8660_PCLK_DIV
#define SCC8660_PCLK_DIV_DEF    (0  )                                           // PCLKƵϵ Ĭϣ0         ѡΪ<0:1/1> <1:2/3> <2:1/2> <3:1/3> <4:1/4> <5:1/8>
                                                                                //              ƵϵԽPCLKƵԽͣPCLKԼDVPӿڵĸţPCLKƵӰ֡ʡ뱣Ĭϡ
                                                                                //              FPSΪ50֡pclkƵϵѡΪ5ͷ֡Ϊ50*1/8=6.25֡
                                                                                //              £SCC8660_PCLK_DIVԽͼԽ
#define SCC8660_PCLK_MODE_DEF   (1  )                                           // PCLKģʽ     Ĭϣ0         ѡΪ[0,1] 0ź 1ź <ͨΪ0ʹSTM32DCMIӿڲɼҪΪ1>
#define SCC8660_COLOR_MODE_DEF  (0  )                                           // ͼɫģʽ Ĭϣ0         ѡΪ[0,1] 0ɫģʽ   1ģʽɫʱͶߣ
#define SCC8660_DATA_FORMAT_DEF (0  )                                           // ݸʽ Ĭϣ0         ѡΪ[0-3] 0RGB565 1RGB565(ֽڽ) 2YUV422(YUYV) 3YUV422(UYVY)
#define SCC8660_MANUAL_WB_DEF   (0  )                                           // ֶƽ   Ĭϣ0         ѡΪ[0,0x65-0xa0] 0رֶƽ⣬Զƽ    ֶƽ ֶƽʱ Χ0x65-0xa0

// ͷö
typedef enum
{
    SCC8660_INIT                = 0x00,                                         // ͷʼ
    SCC8660_AUTO_EXP,                                                           // Զع
    SCC8660_BRIGHT,                                                             // 
    SCC8660_FPS,                                                                // ͷ֡
    SCC8660_SET_COL,                                                            // ͼ
    SCC8660_SET_ROW,                                                            // ͼ
    SCC8660_PCLK_DIV,                                                           // ʱӷƵ
    SCC8660_PCLK_MODE,                                                          // ʱģʽ
    SCC8660_COLOR_MODE,                                                         // ɫģʽ
    SCC8660_DATA_FORMAT,                                                        // ݸʽ
    SCC8660_MANUAL_WB,                                                          // ֶƽ
    SCC8660_CONFIG_FINISH,                                                      // λҪռλ

    SCC8660_GET_WHO_AM_I        = 0xEF,                                         // ˭жͷͺ
    SCC8660_SET_BRIGHT          = 0xF0,                                         // 
    SCC8660_GET_STATUS          = 0XF1,                                         // ȡͷ
    SCC8660_GET_VERSION         = 0xF2,                                         // ̼汾
    SCC8660_SET_MANUAL_WB       = 0xF3,                                         // ֶƽ

    SCC8660_SET_REG_ADDR        = 0xFE,
    SCC8660_SET_REG_DATA        = 0xFF,
}scc8660_cmd_enum;

// ͷӿö
typedef enum
{
    SCC8660_UART,
    SCC8660_SCCB,
}scc8660_type_enum;

extern vuint8       scc8660_finish_flag;                                        // һͼɼɱ־λ
extern uint16       scc8660_image[SCC8660_H][SCC8660_W];

uint16      scc8660_get_id              (void);
uint16      scc8660_get_parameter       (uint16 config);
uint16      scc8660_get_version         (void);
uint8       scc8660_set_bright          (uint16 data);
uint8       scc8660_set_white_balance   (uint16 data);
uint8       scc8660_set_reg             (uint8 addr, uint16 data);

uint8       scc8660_init                (void);

#endif
