/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_driver_dvp
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/

#include "zf_driver_delay.h"
#include "zf_driver_gpio.h"
#include "zf_driver_dvp.h"

//vuint32 frame_cnt = 0;
//vuint32 addr_cnt = 0;
//vuint32 href_cnt = 0;

//-------------------------------------------------------------------------------------------------------------------
//      dvpӿųʼ
// ˵     dvp_d0dvp_d0       ͷD0-D7
// ˵     dvp_pclk            ͷPCLK
// ˵     dvp_vsync           ͷvysnc
// ˵     dvp_herf            ͷherf
// ز     void
// ʹʾ         ڲʹãû
//-------------------------------------------------------------------------------------------------------------------
void dvp_gpio_init(
        uint8 dvp_d0,uint8 dvp_d1,uint8 dvp_d2,uint8 dvp_d3,
        uint8 dvp_d4,uint8 dvp_d5,uint8 dvp_d6,uint8 dvp_d7,
        uint8 dvp_pclk,uint8 dvp_vsync,uint8 dvp_hsync)
{
    //DVP_D0  DVP_ D7
    gpio_init(dvp_d0, GPI, 0, GPI_PULL_UP);
    gpio_init(dvp_d1, GPI, 0, GPI_PULL_UP);
    gpio_init(dvp_d2, GPI, 0, GPI_PULL_UP);
    gpio_init(dvp_d3, GPI, 0, GPI_PULL_UP);
    gpio_init(dvp_d4, GPI, 0, GPI_PULL_UP);
    gpio_init(dvp_d5, GPI, 0, GPI_PULL_UP);
    gpio_init(dvp_d6, GPI, 0, GPI_PULL_UP);
    gpio_init(dvp_d7, GPI, 0, GPI_PULL_UP);
    //DVP_VSYNC
    gpio_init(dvp_vsync, GPI, 0, GPI_PULL_UP);
    //DVP_PCLK
    gpio_init(dvp_pclk,  GPI, 0, GPI_PULL_UP);
    //DVP_HSYNC
    gpio_init(dvp_hsync, GPI, 0, GPI_PULL_UP);
}

//-------------------------------------------------------------------------------------------------------------------
//      dvpӿڳʼ
// ˵     *image0                buff0ĵַ
// ˵     *image1                buff1ĵַ
// ˵     col_len                г
// ˵     row_len                г
// ز     void
// ʹʾ            ڲʹãû
//-------------------------------------------------------------------------------------------------------------------
void dvp_camera_init(uint32 *image0_addr, uint32 *image1_addr, uint16 col_len, uint16 row_len)
{
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DVP, ENABLE);

    // ʹ8λɼģʽPCLKزݣHSYNCߵƽЧVSYNCߵƽЧʹDVP
    DVP->CR0 = RB_DVP_D8_MOD | RB_DVP_V_POLAR | RB_DVP_ENABLE;
    // ֡ͼģʽʹDMA
    DVP->CR1 = DVP_RATE_100P | RB_DVP_DMA_EN;

    DVP->ROW_NUM = row_len;                     // rows
    DVP->COL_NUM = col_len;                     // cols

    DVP->DMA_BUF0 = (uint32)image0_addr;        // DMA addr0
    DVP->DMA_BUF1 = (uint32)image1_addr;        // DMA addr1

    // ʹж
    DVP->IER = RB_DVP_IE_FRM_DONE;              // ֡ж

    interrupt_set_priority(DVP_IRQn, 0x0);
    interrupt_enable(DVP_IRQn);

}

