/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_driver_gpio
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/


#include "zf_driver_gpio.h"


GPIO_TypeDef *gpio_group[5] = {GPIOA, GPIOB, GPIOC, GPIOD, GPIOE};

//-------------------------------------------------------------------------------------------------------------------
//      GPIO
// ˵     pin         źѡ (ѡΧ common.h GPIO_PIN_enumöֵȷ)
// ˵     dat         ŵĵƽ״̬ʱЧ 0͵ƽ 1ߵƽ
// ز     void
// ʹʾ     gpio_set_level(D0, 0);//D0͵ƽ
//-------------------------------------------------------------------------------------------------------------------
void gpio_set_level(gpio_pin_enum pin, uint8 dat)
{
    if(dat)
    {
        gpio_high(pin);                                                         // ߵƽ
    }
    else
    {
        gpio_low(pin);                                                          // ͵ƽ
    }
}

//-------------------------------------------------------------------------------------------------------------------
//      GPIO״̬ȡ
// ˵     pin         ѡ (ѡΧ common.h GPIO_PIN_enumöֵȷ)
// ز     uint8       0͵ƽ 1ߵƽ
// ʹʾ     uint8 status = gpio_get_level(D0);//ȡD0ŵƽ
//-------------------------------------------------------------------------------------------------------------------
uint8 gpio_get_level(gpio_pin_enum pin)
{
    return ((gpio_group[(pin & 0xE0) >> 5]->INDR & (((uint16)0x0001) << (pin & 0x1F))) ? 1 : 0);
}

//-------------------------------------------------------------------------------------------------------------------
//      GPIO ת
// ˵     pin         ѡ (ѡΧ common.h GPIO_PIN_enumöֵȷ)
// ز     void        
// ʹʾ     gpio_toggle_level(D5);//D5ŵƽת
//-------------------------------------------------------------------------------------------------------------------
void gpio_toggle_level(gpio_pin_enum pin)
{
    uint8 io_group = (pin & 0xE0) >> 5;
    uint8 io_pin = pin & 0x1F;

    ((gpio_group[io_group]))->OUTDR ^= (uint16)(1 << io_pin);
}

//-------------------------------------------------------------------------------------------------------------------
//      gpio 
// ˵     pin         ѡ (ѡΧ zf_driver_gpio.h  gpio_pin_enum öֵȷ)
// ˵     dir         ŵķ   GPO   룺GPI
// ˵     mode        ŵģʽ (ѡΧ zf_driver_gpio.h  gpio_mode_enum öֵȷ)
// ز     void
// ʹʾ     gpio_set_dir(D5, GPI, GPI_PULL_UP);                             //  D5 Ϊ
// עϢ
//-------------------------------------------------------------------------------------------------------------------
void gpio_set_dir (gpio_pin_enum pin, gpio_dir_enum dir, gpio_mode_enum mode)
{
    GPIO_InitTypeDef GPIO_InitStructure = {0};
    uint8 io_group = (pin & 0xE0) >> 5;
    uint8 io_pin = pin & 0x1F;

    // ź
    GPIO_InitStructure.GPIO_Pin = (uint16)(1 << io_pin);

    // ֻҪٶ
    if(GPO == dir)
    {
        if((uint16)mode >> 8 == 0) GPIO_InitStructure.GPIO_Speed = (GPIOSpeed_TypeDef)(GPIO_Speed_50MHz);    // ֹûд,Ĭ50Mhz
        else GPIO_InitStructure.GPIO_Speed = (gpio_speed_enum)((uint16)mode >> 8);                           // Ѿд˸òֵ
    }

    // ģʽ
    GPIO_InitStructure.GPIO_Mode = (GPIOMode_TypeDef)((uint16)mode & 0xFF);
    GPIO_Init(gpio_group[io_group], &GPIO_InitStructure);
}

//-------------------------------------------------------------------------------------------------------------------
//      GPIOʼ
// ˵     pin         ѡ (ѡΧ common.h GPIO_PIN_enumöֵȷ)
// ˵     dir         ŵķ   GPO   룺GPI
// ˵     dat         ųʼʱõĵƽ״̬ʱЧ 0͵ƽ 1ߵƽ
// ˵     pinconf     ãòzf_gpio.hļGPIOSPEED_enumGPIOMODE_enumöֵȷʹ | 
// ز     void
// ʹʾ     gpio_init(D0, GPO, 1, GPIO_PIN_CONFIG);//D0ʼΪGPIOܡģʽߵƽٶ100MHZ 
//-------------------------------------------------------------------------------------------------------------------
void gpio_init (gpio_pin_enum pin, gpio_dir_enum dir, const uint8 dat, gpio_mode_enum mode)
{
    GPIO_InitTypeDef GPIO_InitStructure = {0};
    uint8 io_group = (pin & 0xE0) >> 5;
    uint8 io_pin = pin & 0x1F;

    // GPIOʹ
    if(0 == io_group)      RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
    else if(1 == io_group) RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    else if(2 == io_group) RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
    else if(3 == io_group) RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);
    else if(4 == io_group) RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE, ENABLE);

    // ź
    GPIO_InitStructure.GPIO_Pin = (uint16)(1 << io_pin);

    // ֻҪٶ
    if(GPO == dir)
    {
        if((uint16)mode >> 8 == 0) GPIO_InitStructure.GPIO_Speed = (GPIOSpeed_TypeDef)(GPIO_Speed_50MHz);    // ֹûд,Ĭ50Mhz
        else GPIO_InitStructure.GPIO_Speed = (gpio_speed_enum)((uint16)mode >> 8);                           // Ѿд˸òֵ
    }

    // ģʽ
    GPIO_InitStructure.GPIO_Mode = (GPIOMode_TypeDef)((uint16)mode & 0xFF);
    GPIO_Init(gpio_group[io_group], &GPIO_InitStructure);

    // ֻҪ״̬
    if(GPO == dir)
    {
        GPIO_WriteBit(gpio_group[io_group], (uint16)(1 << io_pin), dat);
    }
}

