/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_driver_gpio
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/

 
#ifndef _zf_driver_gpio_h
#define _zf_driver_gpio_h

#include "ch32v30x_rcc.h"
#include "ch32v30x_gpio.h"
#include "ch32v30x_exti.h"
#include "zf_common_typedef.h"

typedef enum                                                                    // ö GPIO   öٶ岻û޸
{
    A0 = 0x00,  A1 ,    A2 ,    A3 ,    A4 ,    A5 ,    A6 ,    A7 ,
    A8 ,        A9 ,    A10,    A11,    A12,    A13,    A14,    A15,

    B0 = 0x20,  B1 ,    B2 ,    B3 ,    B4 ,    B5 ,    B6 ,    B7 ,
    B8 ,        B9 ,    B10,    B11,    B12,    B13,    B14,    B15,

    C0 = 0x40,  C1 ,    C2 ,    C3 ,    C4 ,    C5 ,    C6 ,    C7 ,
    C8 ,        C9 ,    C10,    C11,    C12,    C13,    C14,    C15,

    D0 = 0x60,  D1 ,    D2 ,    D3 ,    D4 ,    D5 ,    D6 ,    D7 ,
    D8 ,        D9 ,    D10,    D11,    D12,    D13,    D14,    D15,

    E0 = 0x80,  E1 ,    E2 ,    E3 ,    E4 ,    E5 ,    E6 ,    E7 ,
    E8 ,        E9 ,    E10,    E11,    E12,    E13,    E14,    E15,

    PIN_NULL = 0xFF
}gpio_pin_enum;

typedef enum
{
    GPI = 0,        //  ܽ뷽
    GPO = 1,        //  ܽ
}gpio_dir_enum;

typedef enum
{
    // 
    GPI_ANAOG_IN        = 0x00,         //  ģģʽ
    GPI_FLOATING_IN     = 0x04,         //  ģʽ
    GPI_PULL_DOWN       = 0x28,         //  
    GPI_PULL_UP         = 0x48,         //  

    // 
    GPO_PUSH_PULL       = 0x10,         //  ͨģʽ
    GPO_OPEN_DTAIN      = 0x14,         //  ͨÿ©ģʽ
    GPO_AF_PUSH_PULL    = 0x18,         //  ùģʽ
    GPO_AF_OPEN_DTAIN   = 0x1C,         //  ùܿ©ģʽ
}gpio_mode_enum;

//  궨GPIOŵĬãڳʼGPIOʱдҪ޸
#define GPIO_PIN_CONFIG (SPEED_50MHZ | GPO_PUSH_PULL)
//  궨GPIOжϺŵĬãڳʼGPIOжʱдҪ޸
#define GPIO_INT_CONFIG (GPI_PULL_UP)

typedef enum
{
    SPEED_10MHZ = (0x01 << 8),
    SPEED_2MHZ  = (0x02 << 8),
    SPEED_50MHZ = (0x03 << 8)
}gpio_speed_enum;

typedef enum
{
    GPIO_LOW  = 0,  //  ͵ƽ
    GPIO_HIGH = 1,  //  ߵƽ
}gpio_level_enum;

extern  GPIO_TypeDef *gpio_group[5];



//-------------------------------------------------------------------------------------------------------------------
//      ȡӦ IO ݵַ
// ˵     x           ѡ (ѡΧ zf_driver_gpio.h  gpio_pin_enum öֵȷ)
// ز     uint32      32bit ַ
// ʹʾ     gpio_idr_addr(D5);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
#define     gpio_idr_addr(x)            (0x40040008 + (((x) & 0xFE0) >> 5) * 0x400 + (((x) & 0x1F) / 8))

//-------------------------------------------------------------------------------------------------------------------
//      ȡӦ IO ݵַ
// ˵     x           ѡ (ѡΧ zf_driver_gpio.h  gpio_pin_enum öֵȷ)
// ز     uint32      32bit ַ
// ʹʾ     gpio_odr_addr(D5);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
#define     gpio_odr_addr(x)            (0x4004000C + (((x) & 0xFE0) >> 5) * 0x400 + (((x) & 0x1F) / 8))

//-------------------------------------------------------------------------------------------------------------------
//      ȡӦ IO λĴַ
// ˵     x           ѡ (ѡΧ zf_driver_gpio.h  gpio_pin_enum öֵȷ)
// ز     uint32      32bit ַ
// ʹʾ     gpio_bsrr_addr(D5);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
#define     gpio_bsrr_addr(x)           (0x40040010 + (((x) & 0xFE0) >> 5) * 0x400 + (((x) & 0x1F) / 8))

//-------------------------------------------------------------------------------------------------------------------
//      ȡӦ IO ĸλĴַ
// ˵     x           ѡ (ѡΧ zf_driver_gpio.h  gpio_pin_enum öֵȷ)
// ز     uint32      32bit ַ
// ʹʾ     gpio_brr_addr(D5);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
#define     gpio_brr_addr(x)            (0x40040014 + (((x) & 0xFE0) >> 5) * 0x400 + (((x) & 0x1F) / 8))

//-------------------------------------------------------------------------------------------------------------------
//      Ӧ IO λΪ͵ƽ
// ˵     x           ѡ (ѡΧ zf_driver_gpio.h  gpio_pin_enum öֵȷ)
// ز     void
// ʹʾ     gpio_low(D5);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
#define gpio_low(x)             ((GPIO_TypeDef*)gpio_group[(x>>5)])->BCR   = (uint16)(1 << (x & 0x0F))

//-------------------------------------------------------------------------------------------------------------------
//      Ӧ IO λΪߵƽ
// ˵     x           ѡ (ѡΧ zf_driver_gpio.h  gpio_pin_enum öֵȷ)
// ز     void
// ʹʾ     gpio_high(D5);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
#define gpio_high(x)            ((GPIO_TypeDef*)gpio_group[(x>>5)])->BSHR  = (uint16)(1 << (x & 0x0F))

void    gpio_set_level          (gpio_pin_enum pin, uint8 dat);
uint8   gpio_get_level          (gpio_pin_enum pin);
void    gpio_toggle_level       (gpio_pin_enum pin);
void    gpio_init               (gpio_pin_enum pin, gpio_dir_enum dir, const uint8 dat, gpio_mode_enum mode);


#ifdef      COMPATIBLE_WITH_OLDER_VERSIONS                                           // ݾɰ汾Դӿ
#define     gpio_set(pin, dat)          (gpio_set_level((pin), (dat)))
#define     gpio_get(pin)               (gpio_get_level((pin)))
#define     gpio_dir(pin, dir, mode)    (gpio_set_dir((pin), (dir), (mode)))
#define     gpio_toggle(pin)            (gpio_toggle_level((pin)))
#endif



#endif
