/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_driver_timer
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/

#include "zf_driver_gpio.h"
#include "zf_driver_timer.h"


// ֹ޸ģڲʹ,û
static timer_function_enum timer_function_state[10] =
{
    TIMER_FUNCTION_INIT, TIMER_FUNCTION_INIT,
    TIMER_FUNCTION_INIT, TIMER_FUNCTION_INIT,
    TIMER_FUNCTION_INIT, TIMER_FUNCTION_INIT,
    TIMER_FUNCTION_INIT, TIMER_FUNCTION_INIT,
    TIMER_FUNCTION_INIT, TIMER_FUNCTION_INIT
};

// ֹ޸ģڲʹ,û
static timer_mode_enum timer_mode_state[10] =
{
    TIMER_SYSTEM_CLOCK, TIMER_SYSTEM_CLOCK,
    TIMER_SYSTEM_CLOCK, TIMER_SYSTEM_CLOCK,
    TIMER_SYSTEM_CLOCK, TIMER_SYSTEM_CLOCK,
    TIMER_SYSTEM_CLOCK, TIMER_SYSTEM_CLOCK,
    TIMER_SYSTEM_CLOCK, TIMER_SYSTEM_CLOCK
};

//-------------------------------------------------------------------------------------------------------------------
//       TIMER ȷϹ״̬ ڲ
// ˵     index           TIMER ģ
// ˵     mode            ҪȷĹģ
// ز     uint8           1-ʹ 0-ʹ
// ʹʾ     zf_assert(timer_funciton_check(TIM_1, TIMER_FUNCTION_PWM);
//-------------------------------------------------------------------------------------------------------------------
uint8 timer_funciton_check (timer_index_enum index, timer_function_enum mode)
{
    uint8 return_state = 1;
    if(TIMER_FUNCTION_INIT == timer_function_state[index])
    {
        timer_function_state[index] = mode;
    }
    else if(timer_function_state[index] == mode)
    {
        return_state = 1;
    }
    else
    {
        return_state = 0;
    }
    return return_state;
}

//-------------------------------------------------------------------------------------------------------------------
//      ʱʱ߳ʼ
// ˵     timer_ch      ʱͨ
// ز     void
// עϢ          ڲʹãû
//-------------------------------------------------------------------------------------------------------------------
void timer_clock_enable(timer_index_enum index)
{
    if(TIM_1 == index)        RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE);//ʹܶʱ1ʱ
    else  if(TIM_2 == index)  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);//ʹܶʱ2ʱ
    else  if(TIM_3 == index)  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);//ʹܶʱ3ʱ
    else  if(TIM_4 == index)  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE);//ʹܶʱ4ʱ
    else  if(TIM_5 == index)  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM5, ENABLE);//ʹܶʱ5ʱ
    else  if(TIM_6 == index)  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM6, ENABLE);//ʹܶʱ6ʱ
    else  if(TIM_7 == index)  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM7, ENABLE);//ʹܶʱ7ʱ
    else  if(TIM_8 == index)  RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM8, ENABLE);//ʹܶʱ8ʱ
    else  if(TIM_9 == index)  RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM9, ENABLE);//ʹܶʱ9ʱ
    else  if(TIM_10== index)  RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM10,ENABLE);//ʹܶʱ10ʱ
}



//-------------------------------------------------------------------------------------------------------------------
//      ʱʼ
// ˵     timer_ch      ѡģͨ (ѡΧ TIMERN_enumöֵȷ)
// ز     void
// ʹʾ     timer_start(TIM_1, TIMER_US);  //ʱ1 ʼÿһusһ
//-------------------------------------------------------------------------------------------------------------------
void timer_start(timer_index_enum index)
{
    TIM_TypeDef *tim_index = TIM1;
    switch(index)
    {
        case TIM_1:  tim_index = ((TIM_TypeDef *)TIM1_BASE);    break;
        case TIM_2:  tim_index = ((TIM_TypeDef *)TIM2_BASE);    break;
        case TIM_3:  tim_index = ((TIM_TypeDef *)TIM3_BASE);    break;
        case TIM_4:  tim_index = ((TIM_TypeDef *)TIM4_BASE);    break;
        case TIM_5:  tim_index = ((TIM_TypeDef *)TIM5_BASE);    break;
        case TIM_6:  tim_index = ((TIM_TypeDef *)TIM6_BASE);    break;
        case TIM_7:  tim_index = ((TIM_TypeDef *)TIM7_BASE);    break;
        case TIM_8:  tim_index = ((TIM_TypeDef *)TIM8_BASE);    break;
        case TIM_9:  tim_index = ((TIM_TypeDef *)TIM9_BASE);    break;
        case TIM_10: tim_index = ((TIM_TypeDef *)TIM10_BASE);   break;
    }
    TIM_Cmd(tim_index, ENABLE);                                          // ʹTIMx
}


//-------------------------------------------------------------------------------------------------------------------
//      رռʱ
// ˵     timer_ch      ѡģͨ (ѡΧ TIMERN_enumöֵȷ)
// ز     void
// עϢ             رնʱ־λ
//-------------------------------------------------------------------------------------------------------------------
void timer_stop(timer_index_enum index)
{
    TIM_TypeDef *tim_index = TIM1;

    switch(index)
    {
        case TIM_1:  tim_index = ((TIM_TypeDef *)TIM1_BASE);    break;
        case TIM_2:  tim_index = ((TIM_TypeDef *)TIM2_BASE);    break;
        case TIM_3:  tim_index = ((TIM_TypeDef *)TIM3_BASE);    break;
        case TIM_4:  tim_index = ((TIM_TypeDef *)TIM4_BASE);    break;
        case TIM_5:  tim_index = ((TIM_TypeDef *)TIM5_BASE);    break;
        case TIM_6:  tim_index = ((TIM_TypeDef *)TIM6_BASE);    break;
        case TIM_7:  tim_index = ((TIM_TypeDef *)TIM7_BASE);    break;
        case TIM_8:  tim_index = ((TIM_TypeDef *)TIM8_BASE);    break;
        case TIM_9:  tim_index = ((TIM_TypeDef *)TIM9_BASE);    break;
        case TIM_10: tim_index = ((TIM_TypeDef *)TIM10_BASE);   break;
    }

    TIM_Cmd(tim_index, DISABLE);  //ʧTIM
}


//-------------------------------------------------------------------------------------------------------------------
//      ȡʱֵ
// ˵     timer_ch      ѡģͨ (ѡΧ TIMERN_enumöֵȷ)
// ز     uint32      ֵ
// ʹʾ     timer_get(TIM_1)  //ȡʱ1ļʱʱ
//-------------------------------------------------------------------------------------------------------------------
uint16 timer_get(timer_index_enum index)
{
    TIM_TypeDef *tim_index = TIM1;
    uint16 return_value = 0;

    switch(index)
    {
        case TIM_1:  tim_index = ((TIM_TypeDef *)TIM1_BASE);    break;
        case TIM_2:  tim_index = ((TIM_TypeDef *)TIM2_BASE);    break;
        case TIM_3:  tim_index = ((TIM_TypeDef *)TIM3_BASE);    break;
        case TIM_4:  tim_index = ((TIM_TypeDef *)TIM4_BASE);    break;
        case TIM_5:  tim_index = ((TIM_TypeDef *)TIM5_BASE);    break;
        case TIM_6:  tim_index = ((TIM_TypeDef *)TIM6_BASE);    break;
        case TIM_7:  tim_index = ((TIM_TypeDef *)TIM7_BASE);    break;
        case TIM_8:  tim_index = ((TIM_TypeDef *)TIM8_BASE);    break;
        case TIM_9:  tim_index = ((TIM_TypeDef *)TIM9_BASE);    break;
        case TIM_10: tim_index = ((TIM_TypeDef *)TIM10_BASE);   break;
    }


    if(timer_mode_state[index] == TIMER_MS)
    {
        return_value = tim_index->CNT/3;
    }
    else
    {
        return_value = tim_index->CNT;
    }
    return return_value;
}



//-------------------------------------------------------------------------------------------------------------------
//      TIMER ʱ
// ˵     index           TIMER ģ
// ز     void
// ʹʾ     timer_clear(TIM_1);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
void timer_clear (timer_index_enum index)
{
    TIM_TypeDef *tim_index = TIM1;

    switch(index)
    {
        case TIM_1:  tim_index = ((TIM_TypeDef *)TIM1_BASE);    break;
        case TIM_2:  tim_index = ((TIM_TypeDef *)TIM2_BASE);    break;
        case TIM_3:  tim_index = ((TIM_TypeDef *)TIM3_BASE);    break;
        case TIM_4:  tim_index = ((TIM_TypeDef *)TIM4_BASE);    break;
        case TIM_5:  tim_index = ((TIM_TypeDef *)TIM5_BASE);    break;
        case TIM_6:  tim_index = ((TIM_TypeDef *)TIM6_BASE);    break;
        case TIM_7:  tim_index = ((TIM_TypeDef *)TIM7_BASE);    break;
        case TIM_8:  tim_index = ((TIM_TypeDef *)TIM8_BASE);    break;
        case TIM_9:  tim_index = ((TIM_TypeDef *)TIM9_BASE);    break;
        case TIM_10: tim_index = ((TIM_TypeDef *)TIM10_BASE);   break;
    }
    tim_index->CNT = 0;
}

//-------------------------------------------------------------------------------------------------------------------
//      TIMER ʱʼ
// ˵     index           TIMER ģ
// ˵     mode            ʱʽ
// ز     void
// ʹʾ     timer_init(TIM_1, TIMER_US);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
void timer_init(timer_index_enum index, timer_mode_enum mode)
{

    // ˶Ϣ ʾλ
    // ȥ鿴ʲôط Ĵ
    // ǼǷظʹöʱ
    // ʼ TIM1_PWM Ȼֳʼ TIM_1 ÷ǲ
    zf_assert(timer_funciton_check(index, TIMER_FUNCTION_TIMER));
    timer_function_state[index] = TIMER_FUNCTION_TIMER;

    TIM_TypeDef *tim_index = TIM1;
    switch(index)
    {
        case TIM_1:  tim_index = ((TIM_TypeDef *)TIM1_BASE);    break;
        case TIM_2:  tim_index = ((TIM_TypeDef *)TIM2_BASE);    break;
        case TIM_3:  tim_index = ((TIM_TypeDef *)TIM3_BASE);    break;
        case TIM_4:  tim_index = ((TIM_TypeDef *)TIM4_BASE);    break;
        case TIM_5:  tim_index = ((TIM_TypeDef *)TIM5_BASE);    break;
        case TIM_6:  tim_index = ((TIM_TypeDef *)TIM6_BASE);    break;
        case TIM_7:  tim_index = ((TIM_TypeDef *)TIM7_BASE);    break;
        case TIM_8:  tim_index = ((TIM_TypeDef *)TIM8_BASE);    break;
        case TIM_9:  tim_index = ((TIM_TypeDef *)TIM9_BASE);    break;
        case TIM_10: tim_index = ((TIM_TypeDef *)TIM10_BASE);   break;
    }



    timer_clock_enable(index);                                                  // ʱ

    timer_mode_state[index] = mode;

    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure = {0};
    if(mode == TIMER_US)
    {
        TIM_TimeBaseStructure.TIM_Period = 0xFFFF;                              // װԶװֵ
        TIM_TimeBaseStructure.TIM_Prescaler = (system_clock/1000000)-1;         // װԤƵ
    }
    else if(mode == TIMER_MS)
    {
        TIM_TimeBaseStructure.TIM_Period = 0xFFFF;                              // װԶװֵ
        TIM_TimeBaseStructure.TIM_Prescaler = (system_clock/1000)/3-1;          // װԤƵ
    }
    else
    {
        TIM_TimeBaseStructure.TIM_Period = 0xFFFF;                              // װԶװֵ
        TIM_TimeBaseStructure.TIM_Prescaler = 0;                                // װԤƵ
    }
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;                     // ʱӷָ:TDTS = Tck_tim
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;                 // TIMϼģʽ
    TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;                            // ظΪ0
    TIM_TimeBaseInit(tim_index, &TIM_TimeBaseStructure);                        // ָĲʼTIMxʱλ

    TIM_Cmd(tim_index, ENABLE);                                                 // ʹTIMx
}

