/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_driver_uart
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/

#ifndef _zf_driver_uart_h
#define _zf_driver_uart_h

#include "ch32v30x.h"
#include "ch32v30x_gpio.h"
#include "ch32v30x_rcc.h"
#include "ch32v30x_usart.h"

#include "zf_common_interrupt.h"
#include "zf_common_debug.h"
#include "zf_driver_gpio.h"

//  öٶ岻û޸
//  ʼʱ򣬱ʹͬһ磬UART1_MAP_TX_A9UART1_MAP_RX_A10һ
//
typedef enum //  öٶ岻û޸
{
    // MAP0  Ĭӳ
    // MAP1  ӳ
    // MAP2  ӳ
    // MAP3  ȫӳ

    //----------UART1-----------//
    // Ϊ1һӳţӳŻá
    // 磺UART1_MAP0_TX_A9UART1_MAP1_TX_B6һʹá

    // Ĭӳ
    UART1_MAP0_TX_A9  = 0x0000 | A9 ,
    UART1_MAP0_RX_A10 = 0x0000 | A10,

    // Ϊ1һӳţӳŻá
    // ӳ               
    UART1_MAP1_TX_B6  = 0x0100 | B6 ,
    UART1_MAP1_RX_B7  = 0x0100 | B7 ,

    // Ϊ1һӳţӳŻá
    // ӳ             
    UART1_MAP2_TX_B15 = 0x0200 | B15,
    UART1_MAP2_RX_A8  = 0x0200 | A8 ,

    // Ϊ1һӳţӳŻá
    // ȫӳ             
    UART1_MAP3_TX_A6  = 0x0300 | A6 ,
    UART1_MAP3_RX_A7  = 0x0300 | A7 ,

    //----------UART2-----------//

    // Ϊ2һӳţӳŻá
    // Ĭӳ
    UART2_MAP0_TX_A2  = 0x1000 | A2 ,
    UART2_MAP0_RX_A3  = 0x1000 | A3 ,

    // Ϊ2һӳţӳŻá
    // ӳ               
    UART2_MAP1_TX_D5  = 0x1100 | D5 ,
    UART2_MAP1_RX_D6  = 0x1100 | D6 ,
                            
    //----------UART3--------------//

    // Ϊ3һӳţӳŻá
    // Ĭӳ             
    UART3_MAP0_TX_B10 = 0x2000 | B10,               // Ĭ
    UART3_MAP0_RX_B11 = 0x2000 | B11,               // Ĭ

    // Ϊ3һӳţӳŻá
    // ӳ               
    UART3_MAP1_TX_C10 = 0x2100 | C10,
    UART3_MAP1_RX_C11 = 0x2100 | C11,

    // Ϊ3һӳţӳŻá
    // ȫӳ             
    UART3_MAP2_TX_D8  = 0x2300 | D8 ,
    UART3_MAP2_RX_D9  = 0x2300 | D9 ,

    //----------UART4-----------//

    // Ϊ4һӳţӳŻá
    // Ĭӳ
    UART4_MAP0_TX_C10 = 0x3000 | C10,
    UART4_MAP0_RX_C11 = 0x3000 | C11,

    // Ϊ4һӳţӳŻá
    // ӳ               
    UART4_MAP1_TX_B0  = 0x3100 | B0 ,
    UART4_MAP1_RX_B1  = 0x3100 | B1 ,

    // Ϊ4һӳţӳŻá
    // ȫӳ             
    UART4_MAP3_TX_E0  = 0x3300 | E0 ,
    UART4_MAP3_RX_E1  = 0x3300 | E1 ,

    //----------UART5-----------//

    // Ϊ5һӳţӳŻá
    // Ĭӳ
    UART5_MAP0_TX_C12 = 0x4000 | C12,
    UART5_MAP0_RX_D2  = 0x4000 | D2,

    // Ϊ5һӳţӳŻá
    // ӳ                
    UART5_MAP1_TX_B4  = 0x4100 | B4,
    UART5_MAP1_RX_B5  = 0x4100 | B5,

    // Ϊ5һӳţӳŻá
    // ȫӳ             
    UART5_MAP3_TX_E8  = 0x4300 | E8,
    UART5_MAP3_RX_E9  = 0x4300 | E9,

    //----------UART6-----------//

    // Ϊ6һӳţӳŻá
    // Ĭӳ
    UART6_MAP0_TX_C0  = 0x5000 | C0 ,
    UART6_MAP0_RX_C1  = 0x5000 | C1 ,

    // Ϊ6һӳţӳŻá
    // ӳ                
    UART6_MAP1_TX_B8  = 0x5100 | B8 ,
    UART6_MAP1_RX_B9  = 0x5100 | B9 ,

    // Ϊ6һӳţӳŻá
    // ȫӳ             
    UART6_MAP3_TX_E10 = 0x5300 | E10,
    UART6_MAP3_RX_E11 = 0x5300 | E11,

    //----------UART7-----------//

    // Ϊ7һӳţӳŻá
    // Ĭӳ
    UART7_MAP0_TX_C2  = 0x6000 | C2 ,
    UART7_MAP0_RX_C3  = 0x6000 | C3 ,

    // Ϊ7һӳţӳŻá
    // ӳ                
    UART7_MAP1_TX_A6  = 0x6100 | A6 ,
    UART7_MAP1_RX_A7  = 0x6100 | A7 ,

    // Ϊ7һӳţӳŻá
    // ȫӳ             
    UART7_MAP3_TX_E12 = 0x6300 | E12,
    UART7_MAP3_RX_E13 = 0x6300 | E13,

    //----------UART8-----------//

    // Ϊ8һӳţӳŻá
    // Ĭӳ
    UART8_MAP0_TX_C4  = 0x7000 | C4 ,
    UART8_MAP0_RX_C5  = 0x7000 | C5 ,

    // Ϊ8һӳţӳŻá
    // ӳ                
    UART8_MAP1_TX_A14 = 0x7100 | A14,
    UART8_MAP1_RX_A15 = 0x7100 | A15,

    // Ϊ8һӳţӳŻá
    // ȫӳ             
    UART8_MAP3_TX_E14 = 0x7300 | E14,
    UART8_MAP3_RX_E15 = 0x7300 | E15,

}uart_pin_enum;


typedef enum//  öٶ岻û޸
{
    UART_1,
    UART_2,
    UART_3,
    UART_4,
    UART_5,
    UART_6,
    UART_7,
    UART_8,
}uart_index_enum;



extern const uint32 uart_index[];




void    uart_write_byte         (uart_index_enum uart_n, const uint8 dat);
void    uart_write_buffer       (uart_index_enum uart_n, const uint8 *buff, uint32 len);
void    uart_write_string       (uart_index_enum uart_n, const char *str);

uint8   uart_read_byte                      (uart_index_enum uartn);
uint8   uart_query_byte                     (uart_index_enum uartn, uint8 *dat);

void    uart_tx_interrupt       (uart_index_enum uart_n, uint8 status);
void    uart_rx_interrupt       (uart_index_enum uart_n, uint8 status);

void    uart_init               (uart_index_enum uart_n, uint32 baud, uart_pin_enum tx_pin, uart_pin_enum rx_pin);



#endif
