/*
 * Scheduler.c
 *
 *  Created on: 20231221
 *      Author: www54
 */
#include "Scheduler.h"

volatile uint64_t tim6_cnt = 0;
volatile uint32 image_time[4] = {0};



void get_circulatetime_for_here(void)
{
    image_time[0] = image_time[1];
    image_time[1] = GetSysTime_us();
    image_time[2] = image_time[1] - image_time[0];
}

static void tim6_task_1ms(void) //˴Ҫ̬ƴ
{
/********************************************û********************************************/

/********************************************û********************************************/
}

static void tim6_task_10ms(void)
{
    if (tim6_cnt%10 == 0) {
/********************************************û********************************************/
        if ((mt9v03x_finish_flag == 1) && (start_image_flag == 0)) {  //һ֡ͼ,һ֡ͼ
            mt9v03x_finish_flag = 0;//ͼ״̬־λ
            image_busy_flag = image_buff_flag; //Ҫͼͼַ
            switch_image_buff(); //һ֡ͼ񻺴ĵַʼͼ
            start_image_flag = 1; //ͼʼ־
        }
/********************************************û********************************************/
    }
}

static void tim6_task_50ms(void)
{
    if (tim6_cnt%50 == 0) {
/********************************************û********************************************/

/********************************************û********************************************/
    }
}

static void tim6_task_100ms(void) {
    if (tim6_cnt % 100 == 0) {
/********************************************û********************************************/

/********************************************û********************************************/
    }
}

static void tim6_task_500ms(void) {
    if (tim6_cnt % 500 == 0) {
/********************************************û********************************************/
        toggle_status_led(green);
/********************************************û********************************************/
    }
}

static void tim6_task_1000ms(void) {
    if (tim6_cnt % 1000 == 0) {
/********************************************û********************************************/

/********************************************û********************************************/
    }
}

void timer_1ms_interrupt_init(void)
{
    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure = {0};

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM6, ENABLE);

    TIM_TimeBaseInitStructure.TIM_Period = 1000-1;
    TIM_TimeBaseInitStructure.TIM_Prescaler = (system_clock/1000000)-1;
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInitStructure.TIM_RepetitionCounter =  0x00;
    TIM_TimeBaseInit(TIM6, &TIM_TimeBaseInitStructure);

    interrupt_set_priority(TIM6_IRQn, 0);
    interrupt_enable(TIM6_IRQn);

    TIM_ITConfig(TIM6, TIM_IT_Update, ENABLE);
    TIM_ARRPreloadConfig(TIM6, ENABLE);
    TIM_Cmd(TIM6, ENABLE);
}

void TIM6_IRQHandler(void) __attribute__((interrupt()));
void TIM6_IRQHandler(void)
{
    if(TIM_GetITStatus(TIM6, TIM_IT_Update) != RESET)
    {
//        TIM_ClearITPendingBit(TIM6, TIM_IT_Update);
        tim6_cnt++;
        tim6_task_1ms();
        tim6_task_10ms();
        tim6_task_50ms();
        tim6_task_100ms();
        tim6_task_500ms();
        tim6_task_1000ms();
        TIM_ClearITPendingBit(TIM6, TIM_IT_Update);
    }
}

