/*
 * bsp_application.h
 *
 *  Created on: 20231220
 *      Author: www54
 */

#ifndef BSP_APPLICATION_H_
#define BSP_APPLICATION_H_

#include "zf_common_headfile.h"

#define RED_LED_PIN             (C2)
#define GREEN_LED_PIN           (C1)
#define BLUE_LED_PIN            (C0)



typedef enum
{
    red,
    green,
    blue,
    purple,
    skybule,
    white,
}led_color;

extern uint8 exti_state[4];

void system_status_led_init(void);
void open_status_led(led_color ledcolor);
void close_status_led(led_color ledcolor);
void toggle_status_led(led_color ledcolor);
void paramUi(void);
void funcInitStatusDisplay(const char dat[], uint8_t init_status);


#endif /* BSP_APPLICATION_H_ */
