/*
 * image.h
 *
 *  Created on: 20231221
 *      Author: www54
 */

#ifndef IMAGE_H_
#define IMAGE_H_

#include "zf_common_headfile.h"

#define N 20 // 廬ƽĴڴС

extern uint8 mt9v03x_image_buff1[MT9V03X_H][MT9V03X_W];
extern uint8 mt9v03x_image_buff2[MT9V03X_H][MT9V03X_W];
extern uint8 (*image_buff_flag)[MT9V03X_W];
extern uint8 (*image_busy_flag)[MT9V03X_W];
extern volatile uint8 start_image_flag;

//======================================ͼ㷨================================================
uint8_t otsu_ThresholdCalculate(const uint8_t *image, uint16_t col_len, uint16_t row_len);
uint8_t add_threshold_and_get_average(uint8_t new_threshold);
void binarize_image(uint8 *image, uint8_t threshold);
//======================================ͼ㷨================================================

void switch_image_buff(void);
void self_dvp_camera_init(uint32 *image0_addr, uint32 *image1_addr, uint16 col_len, uint16 row_len);
uint8 self_mt9v03x_init(void);

#endif /* IMAGE_H_ */
