/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_common_interrupt
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/


#include "zf_common_interrupt.h"

static uint32 interrupt_nest_count = 0;


//-------------------------------------------------------------------------------------------------------------------
//       ָжʹ
// ˵     irqn            ָжϺ ɲ鿴 isr.c ӦжϷıע
// ز     void
// ʹʾ     interrupt_enable(UART1_IRQn);
//-------------------------------------------------------------------------------------------------------------------
void interrupt_enable (IRQn_Type irqn)
{
    NVIC_EnableIRQ(irqn);
}

//-------------------------------------------------------------------------------------------------------------------
//       ָж
// ˵     irqn            ָжϺ ɲ鿴 isr.c ӦжϷıע
// ز     void
// ʹʾ     interrupt_disable(UART1_IRQn);
//-------------------------------------------------------------------------------------------------------------------
void interrupt_disable (IRQn_Type irqn)
{
    NVIC_DisableIRQ(irqn);
}

//-------------------------------------------------------------------------------------------------------------------
//       ָжȼ
// ˵     irqn            ָжϺ ɲ鿴 isr.c ӦжϷıע
// ˵     priority        bit7-bit5Ϊռȼbit4-bit0ΪȼֵԽȼԽ
// ز     void
// ʹʾ     interrupt_enable(UART1_IRQn, (1<<5) | 2);
//                              ռȼΪ1,ȼΪ2
//                              ֹch32v30x_miscĺ
//-------------------------------------------------------------------------------------------------------------------
void interrupt_set_priority (IRQn_Type irqn, uint8 priority)
{
    NVIC_SetPriority(irqn, priority);
}

////-------------------------------------------------------------------------------------------------------------------
//// @brief       жʼ clock_init ڲ
//// @param       void
//// @return      void
//// Sample usage:                interrupt_init();
////-------------------------------------------------------------------------------------------------------------------
//void interrupt_init (void)
//{
//    NVIC_PriorityGroupConfig(4);
//
//}

//-------------------------------------------------------------------------------------------------------------------
//       ȫжʹ
// ˵     void            ԭǶײ  0 ֱǶײж
// ز     void
// ʹʾ     interrupt_global_enable();
//-------------------------------------------------------------------------------------------------------------------
void interrupt_global_enable (uint32 primask)
{
    if(primask)
    {
        interrupt_nest_count --;
    }
    if(!interrupt_nest_count)
    {
        __enable_irq();
    }
}

//-------------------------------------------------------------------------------------------------------------------
//       ȫж
// ˵     void
// ز     void
// ʹʾ     interrupt_disable_all();
//-------------------------------------------------------------------------------------------------------------------
uint32 interrupt_global_disable (void)
{

    if(!interrupt_nest_count)
    {
        __disable_irq();
    }
    interrupt_nest_count ++;
    return interrupt_nest_count;
}

//-------------------------------------------------------------------------------------------------------------------
//      жϳʼ
// ˵     void
// ز     void
// ʹʾ     interrupt_init();
// עϢ       clock_init ڲ
//-------------------------------------------------------------------------------------------------------------------
void interrupt_init (void)
{
    interrupt_global_enable(0);  //ʹȫж
}
