/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_device_w25q32
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/
/*********************************************************************************************************************
* ߶壺
*                   ------------------------------------
*                   ģܽ                                        Ƭܽ
*                   //------------------Ӳ SPI ------------------//
*                   SPC                 鿴 zf_device_w25q32.h  W25Q32_SPC_PIN 궨
*                   SDI                 鿴 zf_device_w25q32.h  W25Q32_SDI_PIN 궨
*                   SDO                 鿴 zf_device_w25q32.h  W25Q32_SDO_PIN 궨
*                   CS                  鿴 zf_device_w25q32.h  W25Q32_CS_PIN 궨
*                   //------------------Ӳ SPI ------------------//
*                   Դ
*                   VCC                 3.3VԴ
*                   GND                 Դ
*                   ------------------------------------
********************************************************************************************************************/

#include "zf_device_w25q32.h"


static uint8 w25q32_read_dat()
{
    //    W25Q32_CS(0);
    uint8 dat = spi_read_8bit(W25Q32_SPI);
    //    W25Q32_CS(1);
    return dat;
}

static void w25q32_read_dats(uint8 *dat, uint32 len)
{
    //    W25Q32_CS(0);
    spi_read_8bit_array(W25Q32_SPI, dat, len);
    //    W25Q32_CS(1);
}

static void w25q32_write_dat(uint8 dat)
{
    //    W25Q32_CS(0);
    spi_write_8bit(W25Q32_SPI, dat);
    //    W25Q32_CS(1);
}


static void w25q32_write_dats(uint8 *dat, uint32 len)
{
    //    W25Q32_CS(0);
    spi_write_8bit_array(W25Q32_SPI, dat, len);
    //    W25Q32_CS(1);
}

//-------------------------------------------------------------------------------------------------------------------
//       дʹ ڲ
// ˵     void
// ز     void
//-------------------------------------------------------------------------------------------------------------------
static void w25q32_write_enable(void)
{
    W25Q32_CS(0);
    w25q32_write_dat(W25Q32_WRITE_ENABLE);   //дʹ
    W25Q32_CS(1);
}

////-------------------------------------------------------------------------------------------------------------------
//// @brief       дʧ ڲ
//// @param       void
//// @return      void
////-------------------------------------------------------------------------------------------------------------------
//static void w25q32_write_disable(void)
//{
//    W25Q32_CS(0);
//    w25q32_write_dat(W25Q32_WRITE_DISABLE);  //дָֹ
//    W25Q32_CS(1);
//}



//-------------------------------------------------------------------------------------------------------------------
//       ȡ״̬ ڲ
// ˵     void
// ز     uint8   Ĵ״ֵ̬
//              BIT7  6   5   4   3   2   1   0
//              SPR   RV  TB BP2 BP1 BP0 WEL BUSY
// Sample usage:
//-------------------------------------------------------------------------------------------------------------------
static uint8 w25q32_read_state(void)
{
    uint8 byte=0;
    W25Q32_CS(0);
    //Ͷȡ״̬Ĵ
    //ȡһֽ
    w25q32_write_dat(W25Q32_READ_STATUS_REG_1);  // Ͷȡ
    byte = w25q32_read_dat();                    // ȡһֽ
    W25Q32_CS(1);
    return byte;
}


//-------------------------------------------------------------------------------------------------------------------
//       ȴæ ڲ
// ˵     void
// ز     void
//-------------------------------------------------------------------------------------------------------------------
static void w25q32_wait_busy(void)
{
    while ((w25q32_read_state()&0x01)==0x01);   // ȴBUSYλ
}


//-------------------------------------------------------------------------------------------------------------------
//       оƬid ڲ
// ˵     void
// ز     uint16   IDֵ
// Sample usage:
//-------------------------------------------------------------------------------------------------------------------
static uint16 w25q32_read_device_id(void)
{
    uint8 send_dat[4] = {W25Q32_DEVICE_ID, 0x00, 0x00, 0x00};
    uint8 read_dat[2] = {0};
    W25Q32_CS(0);
    w25q32_write_dats(send_dat, 4);
    w25q32_read_dats(read_dat, 2);
    W25Q32_CS(1);

    return read_dat[0] << 8 | read_dat[1];
}

//-------------------------------------------------------------------------------------------------------------------
//       W25Q32(Ҫȴ20)
// ˵     void
// ز     void
//-------------------------------------------------------------------------------------------------------------------
void w25q32_erase_chip(void)
{
    w25q32_wait_busy();
    W25Q32_CS(0);                               //ʹ
    w25q32_write_dat(W25Q32_CHIP_ERASE);        //Ƭ
    W25Q32_CS(1);                               //ȡƬѡ
    w25q32_wait_busy();                         //ȴоƬ
}


//-------------------------------------------------------------------------------------------------------------------
//      ȡһֽ ڲ
// ˵     uint32        ȡַ24bit
// ز     uint8           ȡֵ
//  @since      v1.0
// ʹʾ     w25q32_read_byte(0x000001);
//-------------------------------------------------------------------------------------------------------------------
static uint8 w25q32_read_byte(uint32 addr)
{
    uint8 temp;
    W25Q32_CS(0);

    w25q32_write_dat(W25Q32_READ_DATA);       // Ͷȡ
    w25q32_write_dat((uint8)((addr)>>16));    // 24bitַ
    w25q32_write_dat((uint8)((addr)>>8));
    w25q32_write_dat((uint8)addr);
    temp = w25q32_read_dat();                 // ȡһֽ

    W25Q32_CS(1);
    return temp;
}

//-------------------------------------------------------------------------------------------------------------------
//      Уw25q32Ƿ
// ˵     block_num       Ҫд   Χ W25Q32_BLOCK_00   - W25Q32_BLOCK_63
// ˵     sector_num      Ҫд   Χ W25Q32_SECTION_00 - W25Q32_SECTION_15
// ˵     page_num        ǰҳı       Χ W25Q32_PAGE_00    - W25Q32_PAGE_15
// ز     1ݣ0ûݣҪݵдµӦöв
//  @since      v1.0
// ʹʾ     w25q32_check(W25Q32_BLOCK_63, W25Q32_SECTION_15, W25Q32_PAGE_00);
//-------------------------------------------------------------------------------------------------------------------
uint8 w25q32_check (w25q32_block_enum block_num, w25q32_section_enum sector_num, w25q32_page_enum page_num)
{
    uint16 temp_loop;
    uint32 addr = (W25Q32_BASE_ADDR         +
            W25Q32_BLOCK_SIZE*block_num     +
            W25Q32_SECTION_SIZE*sector_num  +
            W25Q32_PAGE_SIZE*page_num);     // ȡǰַ

    for(temp_loop = 0; temp_loop < W25Q32_PAGE_SIZE; temp_loop++)       // ѭȡ Flash ֵ
    {
        if( w25q32_read_byte(addr + temp_loop) != 0xff )                //  0xff Ǿֵ
            return 1;
    }
    return 0;
}


//-------------------------------------------------------------------------------------------------------------------
//      һ
// ˵     block_num       Ҫд   Χ W25Q32_BLOCK_00   - W25Q32_BLOCK_63
// ˵     sector_num      Ҫд   Χ W25Q32_SECTION_00 - W25Q32_SECTION_15
// ز     
//  @since      v1.0
// ʹʾ     w25q32_erase_sector(W25Q32_BLOCK_63, W25Q32_SECTION_15);
//-------------------------------------------------------------------------------------------------------------------
uint8 w25q32_erase_sector(w25q32_block_enum block_num, w25q32_section_enum sector_num)
{
    uint32 addr = (W25Q32_BASE_ADDR  +
            W25Q32_BLOCK_SIZE*block_num    +
            W25Q32_SECTION_SIZE*sector_num +
            W25Q32_PAGE_SIZE*0);                    // ȡǰַ

    W25Q32_CS(0);

    w25q32_write_dat(W25Q32_SECTOR_ERASE);          // Ͳ
    w25q32_write_dat((uint8)((addr)>>16));          // 24bitַ
    w25q32_write_dat((uint8)((addr)>>8));
    w25q32_write_dat((uint8)addr);

    W25Q32_CS(1);
    w25q32_wait_busy();                             // ȴ
    return 0;
}




//-------------------------------------------------------------------------------------------------------------------
//      Ӹõַʼȡ ڲʹ
// ˵     addr            ʼȡĵַ24bit
// ˵     buff            ݴ洢
// ˵     len             Ҫȡĳ(65535)
// ز     
//  @since      v1.0
// ʹʾ     w25q32_erase_sector(0x000001, buf, 16);
//-------------------------------------------------------------------------------------------------------------------
static void w25q32_read_addr_dats(uint32 addr, uint8 *buff, uint16 len)
{
    W25Q32_CS(0);
    w25q32_write_dat(W25Q32_FAST_READ);             // Ͷȡ
    w25q32_write_dat((uint8)((addr)>>16));          // 24bitַ
    w25q32_write_dat((uint8)((addr)>>8));
    w25q32_write_dat((uint8)addr);
    w25q32_read_dat();                              // ٶȡҪһֽΪֽڡ
    w25q32_read_dats(buff, len);

    W25Q32_CS(1);//ȡƬѡ
}


//-------------------------------------------------------------------------------------------------------------------
//      Ӹõַʼд ڲʹ
// ˵     addr            ʼдĵַ24bit
// ˵     buff            ݴ洢
// ˵     len             Ҫдĳ(256,lenܳҳʣֽ)
// ز     
//  @since      v1.0
// ʹʾ     w25q32_write_addr_dats(0x000001, buf, 16);
//-------------------------------------------------------------------------------------------------------------------
static void w25q32_write_addr_dats(uint32 addr, uint8 *buff, uint16 len)
{

    W25Q32_CS(0);

    w25q32_write_dat(W25Q32_PAGE_PROGRAM);          // дҳ
    w25q32_write_dat((uint8)((addr)>>16));          // 24bitַ
    w25q32_write_dat((uint8)((addr)>>8));
    w25q32_write_dat((uint8)addr);
    w25q32_write_dats(buff, len);
    W25Q32_CS(1);
    w25q32_wait_busy();                             // ȴд
}

//-------------------------------------------------------------------------------------------------------------------
//      ȡһҳ
// ˵     block_num       Ҫȡ   Χ W25Q32_BLOCK_00   - W25Q32_BLOCK_63
// ˵     sector_num      Ҫȡ   Χ W25Q32_SECTION_00 - W25Q32_SECTION_15
// ˵     page_num        Ҫȡҳ       Χ W25Q32_PAGE_00    - W25Q32_PAGE_15
// ˵     buf             Ҫȡݵַ   ͱΪuint8 *
// ˵     len             Ҫȡݳ   Χ 1-256
// ز     NULL
//  @since      v1.0
// עϢ
//-------------------------------------------------------------------------------------------------------------------
void w25q32_read_page(w25q32_block_enum block_num, w25q32_section_enum sector_num, w25q32_page_enum page_num,
        uint8 *buf, uint16 len)
{
    uint32  addr = (W25Q32_BASE_ADDR  +
            W25Q32_BLOCK_SIZE*block_num    +
            W25Q32_SECTION_SIZE*sector_num +
            W25Q32_PAGE_SIZE*page_num);     // ȡǰ Flash ַ

    w25q32_read_addr_dats(addr, buf, len);
}

//-------------------------------------------------------------------------------------------------------------------
//      дһҳ
// ˵     block_num       Ҫȡ   Χ W25Q32_BLOCK_00   - W25Q32_BLOCK_63
// ˵     sector_num      Ҫȡ   Χ W25Q32_SECTION_00 - W25Q32_SECTION_15
// ˵     page_num        Ҫȡҳ       Χ W25Q32_PAGE_00    - W25Q32_PAGE_15
// ˵     buf             Ҫȡݵַ   ͱΪuint8 *
// ˵     len             Ҫȡݳ   Χ 1-256
// ز     NULL
//  @since      v1.0
// עϢ
//-------------------------------------------------------------------------------------------------------------------
void w25q32_write_page(w25q32_block_enum block_num, w25q32_section_enum sector_num, w25q32_page_enum page_num,
        uint8 *buf, uint16 len)
{
    uint32 flash_addr = (W25Q32_BASE_ADDR  +
            W25Q32_BLOCK_SIZE*block_num    +
            W25Q32_SECTION_SIZE*sector_num +
            W25Q32_PAGE_SIZE*page_num);     // ȡǰ Flash ַ

    w25q32_write_addr_dats(flash_addr, buf, len);
}


//-------------------------------------------------------------------------------------------------------------------
//       Լ ڲ
// ˵     void
// ز     void
//-------------------------------------------------------------------------------------------------------------------
static uint8 w25q32_self_check(void)
{
    uint8 ret = 0;
    uint16 dat = 0;
    volatile int16 timeout_count = W25Q32_TIMEOUT_COUNT;

///* Winbond SPIFalsh ID */
//#define W25Q80                   0XEF13
//#define W25Q16                   0XEF14
//#define W25Q32                   0XEF15
//#define W25Q64                   0XEF16
//#define W25Q128                  0XEF17

    while(((dat & 0xEF10) != 0xEF10) && timeout_count)                                         // ж ID Ƿȷ
    {
       timeout_count--;

       dat = w25q32_read_device_id();

       system_delay_ms(1);
    }

    if(timeout_count < 0)
    {
        ret = 1;
    }
    else
    {
        ret = 0;
    }

    return ret;
}

//-------------------------------------------------------------------------------------------------------------------
//       ʼ W25Q32
// ˵     void
// ز     uint8         1-ʼʧ 0-ʼɹ
// Sample usage:
//-------------------------------------------------------------------------------------------------------------------
uint8 w25q32_init(void)
{
    spi_init(W25Q32_SPI, SPI_MODE0, W25Q32_SPI_SPEED, W25Q32_SPC_PIN, W25Q32_SDI_PIN, W25Q32_SDO_PIN, W25Q32_CS_PIN);

    if( w25q32_self_check() )
    {
        zf_log(0, "W25Q32 self check error.");
        return 1;
    }

    w25q32_write_enable();                    // дʹ
    return 0;
}
