/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_device_wireless_ch573
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/
/*********************************************************************************************************************
* ߶壺
*                   ------------------------------------
*                   ģܽ                                 Ƭܽ
*                   RX                  鿴 zf_device_wireless_ch573.h  WIRELESS_CH573_RX_PIN  궨
*                   TX                  鿴 zf_device_wireless_ch573.h  WIRELESS_CH573_TX_PIN  궨
*                   RTS                 鿴 zf_device_wireless_ch573.h  WIRELESS_CH573_RTS_PIN 궨
*                   VCC                 5V Դ
*                   GND                 Դ
*                   
*                   ------------------------------------
*********************************************************************************************************************/


#ifndef _zf_device_wireless_ch573_h_
#define _zf_device_wireless_ch573_


#include "zf_driver_gpio.h"
#include "zf_driver_uart.h"
#include "zf_driver_delay.h"



#define WIRELESS_CH573_NUMBER            1                                           // CH573ģ Ĭ
#define WIRELESS_CH573_INDEX             UART_2                                      // CH573ģ1 ӦʹõĴں
#define WIRELESS_CH573_BUAD_RATE         115200                                      // CH573ģ1 ӦʹõĴڲ
#define WIRELESS_CH573_TX_PIN            UART2_MAP1_RX_D6                                 // CH573ģ1 Ӧģ TX ҪӵƬ RX
#define WIRELESS_CH573_RX_PIN            UART2_MAP1_TX_D5                                 // CH573ģ1 Ӧģ RX ҪӵƬ TX
#define WIRELESS_CH573_RTS_PIN           E10                                         // CH573ģ1 Ӧģ RTS 


#define WIRELESS_CH573_BUFFER_SIZE       64
#define WIRELESS_CH573_TIMEOUT_COUNT     0x64



void        wireless_ch573_callback      (void);
uint32      wireless_ch573_send_byte         (const uint8 data);
uint32      wireless_ch573_send_buff         (const uint8 *buff, uint32 len);
uint32      wireless_ch573_send_string       (const uint8 *str);
void        wireless_ch573_send_image        (const uint8 *image_addr, uint32 image_size);
uint32      wireless_ch573_read_buff     (uint8 *buff, uint32 len);
uint8       wireless_ch573_init          (void);

#endif
