/*********************************************************************************************************************
* CH32V307VCT6 Opensourec Library CH32V307VCT6 Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļCH32V307VCT6 Դһ
*
* CH32V307VCT6 Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          zf_driver_pit
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MounRiver Studio V1.8.1
* ƽ̨          CH32V307VCT6
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                                                                    ע
* 2022-09-15        W            first version
********************************************************************************************************************/

#ifndef _zf_driver_pit_h
#define _zf_driver_pit_h


#include "zf_common_interrupt.h"


typedef enum                                                                    // ö TIMͨ
{
    TIM1_PIT,
    TIM2_PIT,
    TIM3_PIT,
    TIM4_PIT,
    TIM5_PIT,
    TIM6_PIT,
    TIM7_PIT,
    TIM8_PIT,
    TIM9_PIT,
    TIM10_PIT
}pit_index_enum;



void pit_enable (pit_index_enum pit_n);
void pit_disable (pit_index_enum pit_n);

void pit_init (pit_index_enum pit_n, uint32 period);

//====================================================궨庯====================================================
//-------------------------------------------------------------------------------------------------------------------
//      TIM PIT жϳʼ ms 
// ˵     pit_n           ʹõ PIT 
// ˵     ms              PIT  ms 
// ز     void
// ʹʾ     pit_ms_init(TIM6_PIT, 1);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
#define pit_ms_init(pit_n, ms)  (pit_init((pit_n), (ms) * (system_clock / 1000)))

//-------------------------------------------------------------------------------------------------------------------
//      TIM PIT жϳʼ us 
// ˵     pit_n           ʹõ PIT 
// ˵     us              PIT  us 
// ز     void
// ʹʾ     pit_us_init(TIM6_PIT, 100);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
#define pit_us_init(pit_n, us)  (pit_init((pit_n), (us) * (system_clock / 1000000)))

//====================================================궨庯====================================================

#endif
